/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.kandidatenportal;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.kandidatenportal.boundary.AbstractWvpBenutzerSearchParameters;
import de.ivu.elect.business.kandidatenportal.boundary.WvpBenutzerChangeEvent;
import de.ivu.elect.business.kandidatenportal.boundary.WvpBenutzerConversationStore;
import de.ivu.elect.business.kandidatenportal.boundary.WvpBenutzerExtendedDAO;
import de.ivu.elect.business.kandidatenportal.boundary.WvpBenutzerSearch;
import de.ivu.elect.business.kandidatenportal.boundary.WvpBenutzerSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.kandidatenportal.entity.WvpBenutzer;
import de.ivu.elect.business.kandidatenportal.entity.WvpBenutzerMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractWvpBenutzerSearchView.COMPONENT_NAME)
@View(viewId = AbstractWvpBenutzerSearchView.VIEW_ID, useCase = UseCasePermission.WVP_BENUTZER_SEARCH)
public abstract class AbstractWvpBenutzerSearchView extends AbstractElectSearchView<WvpBenutzer> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wvpBenutzerSearchView";
  
  public static final String VIEW_ID = "/kandidatenportal/wvp-benutzer-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractWvpBenutzerSearchView requestHandler;

  @Inject
  private transient WvpBenutzerExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(WvpBenutzerConversationStore.class)
  protected transient WvpBenutzerConversationStore conversationStore;

  @Inject
  protected transient WvpBenutzerSearch search;

  @Inject
  @ConversationGroup(AbstractWvpBenutzerSearchParameters.class)
  protected transient WvpBenutzerSearchParameters searchParameters;

  @Inject
  protected transient WvpBenutzerMeta entityMeta;

  public AbstractWvpBenutzerSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public WvpBenutzer getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(WvpBenutzer entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public WvpBenutzerSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<WvpBenutzer> getEagerLoadingCollector() {
    return EagerLoadingCollector.<WvpBenutzer> create();
  }

  @Override
  public List<WvpBenutzer> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<WvpBenutzer> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onWvpBenutzerChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WvpBenutzerChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  // elect: Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractWvpBenutzerSearchView {

    @View
    @Inject
    private transient Instance<AbstractWvpBenutzerSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractWvpBenutzerSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
